/* server functions auto-generated by pidl */
#include "gen_ndr/ndr_asyncemsmdb.h"

NTSTATUS dcerpc_server_asyncemsmdb_init(void);

/* asyncemsmdb - dcerpc server boilerplate generated by pidl */


static NTSTATUS asyncemsmdb__op_bind(struct dcesrv_call_state *dce_call, const struct dcesrv_interface *iface, uint32_t if_version)
{
#ifdef DCESRV_INTERFACE_ASYNCEMSMDB_BIND
	return DCESRV_INTERFACE_ASYNCEMSMDB_BIND(dce_call,iface);
#else
	return NT_STATUS_OK;
#endif
}

static void asyncemsmdb__op_unbind(struct dcesrv_connection_context *context, const struct dcesrv_interface *iface)
{
#ifdef DCESRV_INTERFACE_ASYNCEMSMDB_UNBIND
	DCESRV_INTERFACE_ASYNCEMSMDB_UNBIND(context, iface);
#else
	return;
#endif
}

static NTSTATUS asyncemsmdb__op_ndr_pull(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, struct ndr_pull *pull, void **r)
{
	enum ndr_err_code ndr_err;
	uint16_t opnum = dce_call->pkt.u.request.opnum;

	dce_call->fault_code = 0;

	if (opnum >= ndr_table_asyncemsmdb.num_calls) {
		dce_call->fault_code = DCERPC_FAULT_OP_RNG_ERROR;
		return NT_STATUS_NET_WRITE_FAULT;
	}

	*r = talloc_named(mem_ctx,
			  ndr_table_asyncemsmdb.calls[opnum].struct_size,
			  "struct %s",
			  ndr_table_asyncemsmdb.calls[opnum].name);
	NT_STATUS_HAVE_NO_MEMORY(*r);

        /* unravel the NDR for the packet */
	ndr_err = ndr_table_asyncemsmdb.calls[opnum].ndr_pull(pull, NDR_IN, *r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		dcerpc_log_packet(dce_call->conn->packet_log_dir, 
				  &ndr_table_asyncemsmdb, opnum, NDR_IN,
				  &dce_call->pkt.u.request.stub_and_verifier);
		dce_call->fault_code = DCERPC_FAULT_NDR;
		return NT_STATUS_NET_WRITE_FAULT;
	}

	return NT_STATUS_OK;
}

static NTSTATUS asyncemsmdb__op_dispatch(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, void *r)
{
	uint16_t opnum = dce_call->pkt.u.request.opnum;

	switch (opnum) {
	case 0: {
		struct EcDoAsyncWaitEx *r2 = (struct EcDoAsyncWaitEx *)r;
		if (DEBUGLEVEL >= 10) {
			NDR_PRINT_FUNCTION_DEBUG(EcDoAsyncWaitEx, NDR_IN, r2);
		}
		r2->out.result = dcesrv_EcDoAsyncWaitEx(dce_call, mem_ctx, r2);
		if (dce_call->state_flags & DCESRV_CALL_STATE_FLAG_ASYNC) {
			DEBUG(5,("function EcDoAsyncWaitEx will reply async\n"));
		}
		break;
	}

	default:
		dce_call->fault_code = DCERPC_FAULT_OP_RNG_ERROR;
		break;
	}

	if (dce_call->fault_code != 0) {
		dcerpc_log_packet(dce_call->conn->packet_log_dir, 
		          &ndr_table_asyncemsmdb, opnum, NDR_IN,
				  &dce_call->pkt.u.request.stub_and_verifier);
		return NT_STATUS_NET_WRITE_FAULT;
	}

	return NT_STATUS_OK;
}

static NTSTATUS asyncemsmdb__op_reply(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, void *r)
{
	uint16_t opnum = dce_call->pkt.u.request.opnum;

	switch (opnum) {
	case 0: {
		struct EcDoAsyncWaitEx *r2 = (struct EcDoAsyncWaitEx *)r;
		if (dce_call->state_flags & DCESRV_CALL_STATE_FLAG_ASYNC) {
			DEBUG(5,("function EcDoAsyncWaitEx replied async\n"));
		}
		if (DEBUGLEVEL >= 10 && dce_call->fault_code == 0) {
			NDR_PRINT_FUNCTION_DEBUG(EcDoAsyncWaitEx, NDR_OUT | NDR_SET_VALUES, r2);
		}
		if (dce_call->fault_code != 0) {
			DEBUG(2,("dcerpc_fault %s in EcDoAsyncWaitEx\n", dcerpc_errstr(mem_ctx, dce_call->fault_code)));
		}
		break;
	}

	default:
		dce_call->fault_code = DCERPC_FAULT_OP_RNG_ERROR;
		break;
	}

	if (dce_call->fault_code != 0) {
		dcerpc_log_packet(dce_call->conn->packet_log_dir,
		          &ndr_table_asyncemsmdb, opnum, NDR_IN,
				  &dce_call->pkt.u.request.stub_and_verifier);
		return NT_STATUS_NET_WRITE_FAULT;
	}

	return NT_STATUS_OK;
}

static NTSTATUS asyncemsmdb__op_ndr_push(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, struct ndr_push *push, const void *r)
{
	enum ndr_err_code ndr_err;
	uint16_t opnum = dce_call->pkt.u.request.opnum;

	ndr_err = ndr_table_asyncemsmdb.calls[opnum].ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		dce_call->fault_code = DCERPC_FAULT_NDR;
		return NT_STATUS_NET_WRITE_FAULT;
	}

	return NT_STATUS_OK;
}

const struct dcesrv_interface dcesrv_asyncemsmdb_interface = {
	.name		= "asyncemsmdb",
	.syntax_id  = {{0x5261574a,0x4572,0x206e,{0xb2,0x68},{0x6b,0x19,0x92,0x13,0xb4,0xe4}},65536},
	.bind		= asyncemsmdb__op_bind,
	.unbind		= asyncemsmdb__op_unbind,
	.ndr_pull	= asyncemsmdb__op_ndr_pull,
	.dispatch	= asyncemsmdb__op_dispatch,
	.reply		= asyncemsmdb__op_reply,
	.ndr_push	= asyncemsmdb__op_ndr_push
};


static NTSTATUS asyncemsmdb__op_init_server(struct dcesrv_context *dce_ctx, const struct dcesrv_endpoint_server *ep_server)
{
	int i;

	for (i=0;i<ndr_table_asyncemsmdb.endpoints->count;i++) {
		NTSTATUS ret;
		const char *name = ndr_table_asyncemsmdb.endpoints->names[i];

		ret = dcesrv_interface_register(dce_ctx, name, &dcesrv_asyncemsmdb_interface, NULL);
		if (!NT_STATUS_IS_OK(ret)) {
			DEBUG(1,("asyncemsmdb_op_init_server: failed to register endpoint '%s'\n",name));
			return ret;
		}
	}

	return NT_STATUS_OK;
}

static bool asyncemsmdb__op_interface_by_uuid(struct dcesrv_interface *iface, const struct GUID *uuid, uint32_t if_version)
{
	if (dcesrv_asyncemsmdb_interface.syntax_id.if_version == if_version &&
		GUID_equal(&dcesrv_asyncemsmdb_interface.syntax_id.uuid, uuid)) {
		memcpy(iface,&dcesrv_asyncemsmdb_interface, sizeof(*iface));
		return true;
	}

	return false;
}

static bool asyncemsmdb__op_interface_by_name(struct dcesrv_interface *iface, const char *name)
{
	if (strcmp(dcesrv_asyncemsmdb_interface.name, name)==0) {
		memcpy(iface, &dcesrv_asyncemsmdb_interface, sizeof(*iface));
		return true;
	}

	return false;
}

NTSTATUS dcerpc_server_asyncemsmdb_init(void)
{
	NTSTATUS ret;
	struct dcesrv_endpoint_server ep_server;

	/* fill in our name */
	ep_server.name = "asyncemsmdb";

	/* fill in all the operations */
	ep_server.init_server = asyncemsmdb__op_init_server;

	ep_server.interface_by_uuid = asyncemsmdb__op_interface_by_uuid;
	ep_server.interface_by_name = asyncemsmdb__op_interface_by_name;

	/* register ourselves with the DCERPC subsystem. */
	ret = dcerpc_register_ep_server(&ep_server);

	if (!NT_STATUS_IS_OK(ret)) {
		DEBUG(0,("Failed to register 'asyncemsmdb' endpoint server!\n"));
		return ret;
	}

	return ret;
}

