/* header auto-generated by pidl */

#ifndef _PIDL_HEADER_mapistore_notification
#define _PIDL_HEADER_mapistore_notification

#include <util/data_blob.h>
#include <stdint.h>

#include <core/ntstatus.h>

#include <util/debug.h>
#include <gen_ndr/ndr_misc.h>
#ifndef _HEADER_mapistore_notification
#define _HEADER_mapistore_notification

enum interface_vnum
#ifndef USE_UINT_ENUMS
 {
	MAPISTORE_NOTIFICATION_V1=(int)(1),
	MAPISTORE_NOTIFICATION_VMAX=(int)(2)
}
#else
 { __do_not_use_enum_interface_vnum=0x7FFFFFFF}
#define MAPISTORE_NOTIFICATION_V1 ( 1 )
#define MAPISTORE_NOTIFICATION_VMAX ( 2 )
#endif
;

struct session_v1 {
	struct GUID uuid;
	const char * cn;/* [flag(LIBNDR_FLAG_STR_ASCII|LIBNDR_FLAG_STR_NULLTERM)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

union session_ver {
	struct session_v1 v1;/* [case(MAPISTORE_NOTIFICATION_V1)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),nodiscriminant,public] */;

struct mapistore_notification_session {
	enum interface_vnum vnum;
	union session_ver v;/* [switch_is(vnum)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

struct resolver_v1 {
	uint32_t count;/* [range(0,100000)] */
	const char * *hosts;/* [flag(LIBNDR_FLAG_STR_ASCII|LIBNDR_FLAG_STR_NULLTERM),size_is(count)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

union resolver_ver {
	struct resolver_v1 v1;/* [case(MAPISTORE_NOTIFICATION_V1)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),nodiscriminant,public] */;

struct mapistore_notification_resolver {
	enum interface_vnum vnum;
	union resolver_ver v;/* [switch_is(vnum)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

/* bitmap sub_NotificationFlags */
#define sub_WholeStore ( 0x0001 )
#define sub_NewMail ( 0x0002 )
#define sub_ObjectCreated ( 0x0004 )
#define sub_ObjectDeleted ( 0x0008 )
#define sub_ObjectModified ( 0x0010 )
#define sub_ObjectMoved ( 0x0020 )
#define sub_ObjectCopied ( 0x0040 )
#define sub_SearchCompleted ( 0x0080 )
#define sub_TableModified ( 0x0100 )
#define sub_Reserved ( 0x0400 )

struct subscription_object_v1 {
	uint32_t handle;
	uint16_t flags;
	uint64_t fid;
	uint64_t mid;
	uint16_t count;
	uint32_t *properties;
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

struct subscription_v1 {
	uint32_t count;/* [range(0,100)] */
	struct subscription_object_v1 *subscription;/* [size_is(count)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

union subscription_ver {
	struct subscription_v1 v1;/* [case(MAPISTORE_NOTIFICATION_V1)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),nodiscriminant,public] */;

struct mapistore_notification_subscription {
	enum interface_vnum vnum;
	union subscription_ver v;/* [switch_is(vnum)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

struct newmail_v1 {
	const char * backend;/* [flag(LIBNDR_FLAG_STR_ASCII|LIBNDR_FLAG_STR_NULLTERM)] */
	const char * eml;/* [flag(LIBNDR_FLAG_STR_ASCII|LIBNDR_FLAG_STR_NULLTERM)] */
	const char * folder;/* [flag(LIBNDR_FLAG_STR_ASCII|LIBNDR_FLAG_STR_NULLTERM)] */
	uint8_t separator;
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

union notification_data_v1 {
	struct newmail_v1 newmail;/* [case(sub_NewMail)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),nodiscriminant,public] */;

struct notification_v1 {
	uint16_t flags;
	union notification_data_v1 u;/* [switch_is(flags)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

union notification_ver {
	struct notification_v1 v1;/* [case(MAPISTORE_NOTIFICATION_V1)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),nodiscriminant,public] */;

struct mapistore_notification {
	enum interface_vnum vnum;
	union notification_ver v;/* [switch_is(vnum)] */
}/* [flag(LIBNDR_FLAG_NOALIGN),public] */;

#endif /* _HEADER_mapistore_notification */
#endif /* _PIDL_HEADER_mapistore_notification */
